// CnfDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SoftDLL.h"
#include "gpu_i.h"
#include "CnfDlg.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCnfDlg dialog


CCnfDlg::CCnfDlg(CWnd* pParent, GpuConfS *config)
	: CDialog(CCnfDlg::IDD, pParent)
{
	intConfig=config;
	//{{AFX_DATA_INIT(CCnfDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCnfDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCnfDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCnfDlg, CDialog)
	//{{AFX_MSG_MAP(CCnfDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCnfDlg message handlers

void CCnfDlg::OnOK() 
{
	HKEY myKey;
	DWORD myDisp;
	DWORD temp;
	intConfig->scanH=(SendDlgItemMessage(IDC_HSCANL,BM_GETCHECK)==BST_CHECKED)?1:0;
	intConfig->scanV=(SendDlgItemMessage(IDC_VSCANL,BM_GETCHECK)==BST_CHECKED)?1:0;

	RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\Vision Thing\\PSEmu Pro\\GPU\\Soft",0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&myKey,&myDisp);
	temp=intConfig->scanH;
	RegSetValueEx(myKey,"H Lines",0,REG_DWORD,(LPBYTE) &temp, sizeof(temp));
	temp=intConfig->scanV;
	RegSetValueEx(myKey,"V Lines",0,REG_DWORD,(LPBYTE) &temp, sizeof(temp));
	RegCloseKey(myKey);

	CDialog::OnOK();
}

BOOL CCnfDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SendDlgItemMessage(IDC_HSCANL,BM_SETCHECK,intConfig->scanH==1?BST_CHECKED:BST_UNCHECKED,0);
	SendDlgItemMessage(IDC_VSCANL,BM_SETCHECK,intConfig->scanV==1?BST_CHECKED:BST_UNCHECKED,0);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
