#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>

#include "gpu_i.h"

//===============================================================

unsigned short colorR2C[256];
unsigned short colorG2C[256];
unsigned short colorB2C[256];

unsigned short lutBGR2RGB[65536];

short Ymin;
short Ymax;

short Xmin[512]; 
short Xmax[512]; 

long TXmax[512];
long TYmax[512];
long TXmin[512];
long TYmin[512];

long Rmax[512];
long Rmin[512];
long Gmax[512];
long Gmin[512];
long Bmax[512];
long Bmin[512];

short updateLace;
short dispMode;


/*void drawLineG(short x1, short y1, short x2, short y2, long rgb1, long rgb2)
{
 long deltax, deltay, numpixels;
 long i;
 long d, dinc1, dinc2;
 long x, y;
 long xinc1, xinc2;
 long yinc1, yinc2;
 long cR1,cG1,cB1,cR2,cG2,cB2;
 long difR,difB,difG;
 
 cR1=(rgb1>>3) & 0x001f0000;
 cR2=(rgb2>>3) & 0x001f0000;
 cG1=(rgb1<<5) & 0x001f0000;
 cG2=(rgb2<<5) & 0x001f0000;
 cB1=(rgb1<<13) & 0x001f0000;
 cB2=(rgb2<<13) & 0x001f0000;

 deltax = abs(x2-x1);
 deltay = abs(y2-y1);

 if (deltax>=deltay)
  {
   numpixels = deltax;
   d = (2*deltay)-deltax;
   dinc1 = deltay << 1;
   dinc2 = (deltay - deltax) << 1;
   xinc1 = 1;
   xinc2 = 1;
   yinc1 = 0;
   yinc2 = 1;
  }
 else
  {
   numpixels = deltay;
   d = (2*deltax)-deltay;
   dinc1 = deltax << 1;
   dinc2 = (deltax - deltay) << 1;
   xinc1 = 0;
   xinc2 = 1;
   yinc1 = 1;
   yinc2 = 1;
  }

 if (x1>x2)
  {
   xinc1 = (-xinc1);
   xinc2 = (-xinc2);
  }

 if (y1>y2)
  {
   yinc1 = (-yinc1);
   yinc2 = (-yinc2);
   if(y1>drawY && y1<drawH && y1>Ymax) Ymax=y1;
   if(y2>drawY && y2<drawH && y2<Ymin) Ymin=y2;
  }
 else
  {
   if(y1>drawY && y1<drawH && y1<Ymin) Ymin=y1;
   if(y2>drawY && y2<drawH && y2>Ymax) Ymax=y2;
  }
  
 x = x1; y = y1;
 if (numpixels>0)
  {
   difR=(cR2-cR1)/numpixels;
   difG=(cG2-cG1)/numpixels;
   difB=(cB2-cB1)/numpixels;
  }
 else return;
 

 for (i=0;i<numpixels;i++)
  {
   if ((y>drawY && y<drawH)) 
    {
     if(x>drawX && x<drawW)
      {
       psxVW[y*1024+x] = ((cR1 >> 6)&0x7c00)|((cG1 >> 11)&0x03e0)|((cB1 >> 16)&0x001f);
      }
    }
   if (d<0)
    {
     d += dinc1;
     x += xinc1;
     y += yinc1;
    }
   else
    {
     d += dinc2;
     x += xinc2;
     y += yinc2;
    }
   cR1+=difR;
   cG1+=difG;
   cB1+=difB;

  }
}

*/

//===============================================================

void drawLineInBufG(short x1, short y1, short x2, short y2, long rgb1, long rgb2)
{
 long deltax, deltay, numpixels;
 long i;
 long d, dinc1, dinc2;
 long x, y;
 long xinc1, xinc2;
 long yinc1, yinc2;
 long cR1,cG1,cB1,cR2,cG2,cB2;
 long difR,difB,difG;
 
 cR1=(rgb1>>3) & 0x001f0000;
 cR2=(rgb2>>3) & 0x001f0000;
 cG1=(rgb1<<5) & 0x001f0000;
 cG2=(rgb2<<5) & 0x001f0000;
 cB1=(rgb1<<13) & 0x001f0000;
 cB2=(rgb2<<13) & 0x001f0000;

 deltax = abs(x2-x1);
 deltay = abs(y2-y1);

 if (deltax>=deltay)
  {
   numpixels = deltax;
   d = (2*deltay)-deltax;
   dinc1 = deltay << 1;
   dinc2 = (deltay - deltax) << 1;
   xinc1 = 1;
   xinc2 = 1;
   yinc1 = 0;
   yinc2 = 1;
  }
 else
  {
   numpixels = deltay;
   d = (2*deltax)-deltay;
   dinc1 = deltax << 1;
   dinc2 = (deltax - deltay) << 1;
   xinc1 = 0;
   xinc2 = 1;
   yinc1 = 1;
   yinc2 = 1;
  }

 if (x1>x2)
  {
   xinc1 = (-xinc1);
   xinc2 = (-xinc2);
  }

 if (y1>y2)
  {
   yinc1 = (-yinc1);
   yinc2 = (-yinc2);
   if(y1>drawH) Ymax=drawH;
   else if(y1>Ymax) Ymax=y1;
   if(y2<drawY) Ymin = drawY;
   else if(y2<Ymin) Ymin = y2;
  }
 else
  {
   if(y2>drawH) Ymax=drawH;
   else if(y2>Ymax) Ymax=y2;
   if(y1<drawY) Ymin = drawY;
   else if(y1<Ymin) Ymin = y1;
  }
  
 x = x1; y = y1;
 if (numpixels>0)
  {
   difR=(cR2-cR1)/numpixels;
   difG=(cG2-cG1)/numpixels;
   difB=(cB2-cB1)/numpixels;
  }
 else return;
 

 for (i=0;i<numpixels;i++)
  {
   if ((y>drawY && y<drawH)) 
    {
     if (x<drawX) 
      {
       Xmin[y]=drawX;
       Rmin[y]=cR1;
       Gmin[y]=cG1;
       Bmin[y]=cB1;
      }
     else if (x>drawW)
      {
       Xmax[y]=drawW;
       Rmax[y]=cR1;
       Gmax[y]=cG1;
       Bmax[y]=cB1;
      }
     else
      {
       if (x<Xmin[y])
        {
         Xmin[y]=x;
         Rmin[y]=cR1;
         Gmin[y]=cG1;
         Bmin[y]=cB1;
        }
       if (x>Xmax[y])
        {
         Xmax[y]=x;
         Rmax[y]=cR1;
         Gmax[y]=cG1;
         Bmax[y]=cB1;
        }
      }
    }
   if (d<0)
    {
     d += dinc1;
     x += xinc1;
     y += yinc1;
    }
   else
    {
     d += dinc2;
     x += xinc2;
     y += yinc2;
    }
   cR1+=difR;
   cG1+=difG;
   cB1+=difB;

  }
}


void drawLineInBufT(short x1, short y1, short x2, short y2, short tx1, short ty1, short tx2, short ty2)
{
 short deltax, deltay, numpixels;
 long i;
 long d, dinc1, dinc2;
 long x, y;
 long xinc1, xinc2;
 long yinc1, yinc2;
 long deltaTx,deltaTy;
 long posTx,posTy;
 long newTy2,newTx2;
  
 //if(y2<0 || y1<0) return;
	 //syslog(199,"%d %d",drawY,y1);
 deltax = abs(x2-x1);
 deltay = abs(y2-y1);

 if (deltax>=deltay)
  {
   numpixels = deltax;
   d = (2*deltay)-deltax;
   dinc1 = deltay << 1;
   dinc2 = (deltay - deltax) << 1;
   xinc1 = 1;
   xinc2 = 1;
   yinc1 = 0;
   yinc2 = 1;
  }
 else
  {
   numpixels = deltay;
   d = (2*deltax)-deltay;
   dinc1 = deltax << 1;
   dinc2 = (deltax - deltay) << 1;
   xinc1 = 0;
   xinc2 = 1;
   yinc1 = 1;
   yinc2 = 1;
  }

 if (x1>x2)
  {
   xinc1 = (-xinc1);
   xinc2 = (-xinc2);
  }

 if (y1>y2)
  {
   yinc1 = (-yinc1);
   yinc2 = (-yinc2);
   if(y1>drawH) Ymax=drawH;
   else if(y1>Ymax) Ymax=y1;
   if(y2<drawY) Ymin = drawY;
   else if(y2<Ymin) Ymin = y2;
  }
 else
  {
   if(y2>drawH) Ymax=drawH;
   else if(y2>Ymax) Ymax=y2;
   if(y1<drawY) Ymin = drawY;
   else if(y1<Ymin) Ymin = y1;
  }
  
 x = x1; y = y1;

 if (numpixels>0)
  {
   posTx=tx1;
   posTx<<=16;
   posTy=ty1;
   posTy<<=16;
   newTx2=tx2;
   newTx2<<=16;
   newTy2=ty2;
   newTy2<<=16;
   deltaTx=(newTx2-posTx)/numpixels;
   deltaTy=(newTy2-posTy)/numpixels;
  }
 else return;
 

 for (i=0;i<numpixels;i++)
  {
   if ((y>drawY && y<drawH)) 
    {
     if (x<drawX) 
      {
       Xmin[y]=drawX;
       TXmin[y]=posTx;
       TYmin[y]=posTy;
      }
     else if (x>drawW)
      {
       Xmax[y]=drawW;
       TXmax[y]=posTx;
       TYmax[y]=posTy;
      }
     else
      {
       if (x<Xmin[y])
        {
         Xmin[y]=x;
         TXmin[y]=posTx;
         TYmin[y]=posTy;
        }
       if (x>Xmax[y])
        {
         Xmax[y]=x;
         TXmax[y]=posTx;
         TYmax[y]=posTy;
        }
      }
    }
   if (d<0)
    {
     d += dinc1;
     x += xinc1;
     y += yinc1;
    }
   else
    {
     d += dinc2;
     x += xinc2;
     y += yinc2;
    }
   posTx+=deltaTx;
   posTy+=deltaTy;
  }

}


void drawLineInBuf(short x1, short y1, short x2, short y2)
{
 long deltax, deltay, numpixels;
 long i;
 long d, dinc1, dinc2;
 long x, y;
 long xinc1, xinc2;
 long yinc1, yinc2;

 deltax = abs(x2-x1);
 deltay = abs(y2-y1);

 if (deltax>=deltay)
  {
   numpixels = deltax;
   d = (2*deltay)-deltax;
   dinc1 = deltay << 1;
   dinc2 = (deltay - deltax) << 1;
   xinc1 = 1;
   xinc2 = 1;
   yinc1 = 0;
   yinc2 = 1;
  }
 else
  {
   numpixels = deltay;
   d = (2*deltax)-deltay;
   dinc1 = deltax << 1;
   dinc2 = (deltax - deltay) << 1;
   xinc1 = 0;
   xinc2 = 1;
   yinc1 = 1;
   yinc2 = 1;
  }

 if (x1>x2)
  {
   xinc1 = (-xinc1);
   xinc2 = (-xinc2);
  }

 if (y1>y2)
  {
   yinc1 = (-yinc1);
   yinc2 = (-yinc2);
   if(y1>drawH) Ymax=drawH;
   else if(y1>Ymax) Ymax=y1;
   if(y2<drawY) Ymin = drawY;
   else if(y2<Ymin) Ymin = y2;
  }
 else
  {
   if(y2>drawH) Ymax=drawH;
   else if(y2>Ymax) Ymax=y2;
   if(y1<drawY) Ymin = drawY;
   else if(y1<Ymin) Ymin = y1;
  }
  
 x = x1; y = y1;
 if(numpixels<=0) return;
 for (i=0;i<=numpixels;i++)
  {
   if ((y>=drawY && y<=drawH)) 
    {
     if (x<drawX) Xmin[y]=drawX;
     else
      if (x>drawW) Xmax[y]=drawW;
     else
      {
       if (x<Xmin[y]) Xmin[y]=x;
       if (x>Xmax[y]) Xmax[y]=x;
      }
    }
   if (d<0)
    {
     d += dinc1;
     x += xinc1;
     y += yinc1;
    }
   else
    {
     d += dinc2;
     x += xinc2;
     y += yinc2;
    }
  }
}


void drawFlatTriangle(short x1, short y1, short x2, short y2, short x3, short y3, long rgb)
{
 int i,j;
 unsigned short color = 0;
 color = ((rgb & 0x00f80000)>>9) | ((rgb & 0x0000f800)>>6) | ((rgb & 0x000000f8)>>3);
 if(x1>drawW && x2>drawW && x3>drawW) return;
 if(y1>drawH && y2>drawH && y3>drawH) return;
 if(x1<drawX && x2<drawX && x3<drawX) return;
 if(y1<drawY && y2<drawY && y3<drawY) return;
 Ymin = 512;
 Ymax = 0;
 for(i=511;i>=0;i--)
  {
   Xmin[i]=1024; Xmax[i]=0;
  }
 drawLineInBuf(x1,y1,x2,y2);
 drawLineInBuf(x1,y1,x3,y3);
 drawLineInBuf(x3,y3,x2,y2);
 if (Ymin>Ymax) return;
 for (i=Ymin;i<=Ymax;i++)
  {
   if(Xmin[i]<=Xmax[i])
     for(j=Xmin[i];j<=Xmax[i];j++) psxVuw[i*1024+j] = color;
   }
}


void drawPoly4F(short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4, long rgb)
{
 int i,j;
 unsigned short color = 0;

 color = ((rgb & 0x00f80000)>>9) | ((rgb & 0x0000f800)>>6) | ((rgb & 0x000000f8)>>3);
 if(x1>1023 && x2>1023 && x3>1023 && x4>1023) return;
 if(y1>511 && y2>511 && y3>511 && y4>511) return;
 if(x1<0 && x2<0 && x3<0 && x4<0) return;
 if(y1<0 && y2<0 && y3<0 && y4<0) return;
 Ymin = 512;
 Ymax = 0;
 for(i=511;i>=0;i--)
  {
   Xmin[i]=1024; Xmax[i]=0;
  }
 drawLineInBuf(x1,y1,x2,y2);
 drawLineInBuf(x2,y2,x4,y4);
 drawLineInBuf(x4,y4,x3,y3);
 drawLineInBuf(x3,y3,x1,y1);
 if (Ymin>Ymax) return;
 for (i=Ymin;i<=Ymax;i++)
  {
   if(Xmin[i]<=Xmax[i])
     for(j=Xmin[i];j<=Xmax[i];j++) psxVuw[i*1024+j] = color;
   }
}








//---------------------------------------------------------

void drawFlatTriangleGoraud(short x1, short y1, short x2, short y2, short x3, short y3, long rgb1, long rgb2, long rgb3)
{
 long cR1,cR2,cG1,cG2,cB1,cB2;
 long difR,difB,difG;
 long num; 
 long i,j;

 if(x1>drawW && x2>drawW && x3>drawW) return;
 if(y1>drawH && y2>drawH && y3>drawH) return;
 if(x1<drawX && x2<drawX && x3<drawX) return;
 if(y1<drawY && y2<drawY && y3<drawY) return;
 Ymin = 512;
 Ymax = 0;
 for(i=511;i>=0;i--)
  {
   Xmin[i]=1024; Xmax[i]=0;
  }
 drawLineInBufG(x1,y1,x2,y2,rgb1,rgb2);
 drawLineInBufG(x1,y1,x3,y3,rgb1,rgb3);
 drawLineInBufG(x3,y3,x2,y2,rgb3,rgb2);
 if (Ymin>Ymax) return;

 for (i=Ymin;i<=Ymax;i++)
  {
   if(Xmin[i]<=Xmax[i])
     {
      cR1=Rmin[i];
      cR2=Rmax[i];
      cG1=Gmin[i];
      cG2=Gmax[i];
      cB1=Bmin[i];
      cB2=Bmax[i];
      num=(Xmax[i]-Xmin[i]);
      if(num==0)num=1;
      difR=(cR2-cR1)/num;
      difG=(cG2-cG1)/num;
      difB=(cB2-cB1)/num;
      
      for(j=Xmin[i];j<=Xmax[i];j++)
       {
//        color=(((cR1+((difR*j)/num))&0x1f)<<10)|(((cG1+((difG*j)/num))&0x1f)<<5)|(((cB1+((difB*j)/num))&0x1f));
        psxVuw[i*1024+j] = ((cR1 >> 6)&0x7c00)|((cG1 >> 11)&0x03e0)|((cB1 >> 16)&0x001f);
        cR1+=difR;
        cG1+=difG;
        cB1+=difB;
       }
     }
   }
}



void drawPoly4G(short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4, long rgb1, long rgb2, long rgb3, long rgb4)
{
 long difR,difB,difG;
 long num; 
 long i,j;
 register long cR1,cR2,cG1;
 long cG2,cB1,cB2;

 if(x1>drawW && x2>drawW && x3>drawW) return;
 if(y1>drawH && y2>drawH && y3>drawH) return;
 if(x1<drawX && x2<drawX && x3<drawX) return;
 if(y1<drawY && y2<drawY && y3<drawY) return;
 Ymin = 512;
 Ymax = 0;
 for(i=511;i>=0;i--)
  {
   Xmin[i]=1024; Xmax[i]=0;
  }
 drawLineInBufG(x1,y1,x2,y2,rgb1,rgb2);
 drawLineInBufG(x2,y2,x4,y4,rgb2,rgb4);
 drawLineInBufG(x4,y4,x3,y3,rgb4,rgb3);
 drawLineInBufG(x3,y3,x1,y1,rgb3,rgb1);
 
 if (Ymin>Ymax) return;

 for (i=Ymin;i<=Ymax;i++)
  {
   if(Xmin[i]<=Xmax[i])
     {
      cR1=Rmin[i];
      cR2=Rmax[i];
      cG1=Gmin[i];
      cG2=Gmax[i];
      cB1=Bmin[i];
      cB2=Bmax[i];
      num=(Xmax[i]-Xmin[i]);
      if(num==0)num=1;
      difR=(cR2-cR1)/num;
      difG=(cG2-cG1)/num;
      difB=(cB2-cB1)/num;
      
      for(j=Xmin[i];j<=Xmax[i];j++)
       {
        psxVuw[i*1024+j] = ((cR1 >> 6)&0x7c00)|((cG1 >> 11)&0x03e0)|((cB1 >> 16)&0x001f);
        cR1+=difR;
        cG1+=difG;
        cB1+=difB;
       }
     }
   }
}

void drawPoly4T(short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4, short tx1, short ty1, short tx2, short ty2, short tx3, short ty3, short tx4, short ty4)
{
 long num; 
 long i,j;
 long difX, difY;
 long posX,posY;
 unsigned short color;
 
 if(x1>drawW && x2>drawW && x3>drawW && x4>drawW) return;
 if(y1>drawH && y2>drawH && y3>drawH && y4>drawH) return;
 if(x1<drawX && x2<drawX && x3<drawX && x4<drawX) return;
 if(y1<drawY && y2<drawY && y3<drawY && y4<drawY) return;
 Ymin = 512;
 Ymax = 0;
 for(i=511;i>=0;i--)
  {
   Xmin[i]=1024; Xmax[i]=0;
  }
 drawLineInBufT(x1,y1,x2,y2,tx1,ty1,tx2,ty2);
 drawLineInBufT(x2,y2,x3,y3,tx2,ty2,tx3,ty3);
 drawLineInBufT(x3,y3,x4,y4,tx3,ty3,tx4,ty4);
 drawLineInBufT(x4,y4,x1,y1,tx4,ty4,tx1,ty1);
 
 if (Ymin>Ymax) return;

 for (i=Ymin;i<Ymax;i++)
  {
   if(Xmin[i]<=Xmax[i])
     {
      num=(Xmax[i]-Xmin[i]);
      if(num==0)num=1;
      difX=(TXmax[i]-TXmin[i])/num;
      difY=(TYmax[i]-TYmin[i])/num;
      posX=TXmin[i];
      posY=TYmin[i];      
      for(j=Xmin[i];j<Xmax[i];j++)
       {
        if((color = textBuf[(posY>>16)*512+(posX>>16)]))
         psxVuw[i*1024+j] = color;
        posX+=difX;
        posY+=difY;
       }
     }
   }
}

void drawPoly3T(short x1, short y1, short x2, short y2, short x3, short y3, short tx1, short ty1, short tx2, short ty2, short tx3, short ty3)
{
 long num; 
 long i,j;
 long difX, difY;
 long posX,posY;
 unsigned short color;
  
 if(y1<drawY || y2<drawY || y3<drawY) return;

 if(x1>drawW && x2>drawW && x3>drawW) return;
 if(y1>drawH && y2>drawH && y3>drawH) return;
 if(x1<drawX && x2<drawX && x3<drawX) return;
 if(y1<drawY && y2<drawY && y3<drawY) return;
 Ymin = 512;
 Ymax = 0;
 for(i=511;i>=0;i--)
  {
   Xmin[i]=1024; Xmax[i]=0;
  }
 drawLineInBufT(x1,y1,x2,y2,tx1,ty1,tx2,ty2);
 drawLineInBufT(x2,y2,x3,y3,tx2,ty2,tx3,ty3);
 drawLineInBufT(x3,y3,x1,y1,tx3,ty3,tx1,ty1);
 
 if (Ymin>Ymax) return;

 for (i=Ymin;i<Ymax;i++)
  {
   if(Xmin[i]<=Xmax[i])
     {
      num=(Xmax[i]-Xmin[i]);
      if(num==0)num=1;
      difX=(TXmax[i]-TXmin[i])/num;
      difY=(TYmax[i]-TYmin[i])/num;
      posX=TXmin[i];
      posY=TYmin[i];
      for(j=Xmin[i];j<Xmax[i];j++)
       {
        color = textBuf[(posY>>16)*512+(posX>>16)];
        if (color)
         psxVuw[i*1024+j] = color;
        posX+=difX;
        posY+=difY;
       }
     }
   }
}

void drawPoly4TD(short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4, short tx1, short ty1, short tx2, short ty2, short tx3, short ty3, short tx4, short ty4)
{
 long num; 
 long i,j;
 long difX, difY;
 long posX,posY;
 unsigned short color;
 
 if(x1>drawW && x2>drawW && x3>drawW && x4>drawW) return;
 if(y1>drawH && y2>drawH && y3>drawH && y4>drawH) return;
 if(x1<drawX && x2<drawX && x3<drawX && x4<drawX) return;
 if(y1<drawY && y2<drawY && y3<drawY && y4<drawY) return;
 Ymin = 512;
 Ymax = 0;
 for(i=511;i>=0;i--)
  {
   Xmin[i]=1024; Xmax[i]=0;
  }
 drawLineInBufT(x1,y1,x2,y2,tx1,ty1,tx2,ty2);
 drawLineInBufT(x2,y2,x3,y3,tx2,ty2,tx3,ty3);
 drawLineInBufT(x3,y3,x4,y4,tx3,ty3,tx4,ty4);
 drawLineInBufT(x4,y4,x1,y1,tx4,ty4,tx1,ty1);
 
 if (Ymin>Ymax) return;

 for (i=Ymin;i<Ymax;i++)
  {
   if(Xmin[i]<=Xmax[i])
     {
      num=(Xmax[i]-Xmin[i]);
      if(num==0)num=1;
      difX=(TXmax[i]-TXmin[i])/num;
      difY=(TYmax[i]-TYmin[i])/num;
      posX=TXmin[i];
      posY=TYmin[i];      
      for(j=Xmin[i];j<Xmax[i];j++)
       {
        if((color = psxVuw[((posY>>16)+textAddrY)*1024+(posX>>16)+textAddrX]))
         psxVuw[i*1024+j] = color;
        posX+=difX;
        posY+=difY;
       }
     }
   }
}


void drawPoly3TD(short x1, short y1, short x2, short y2, short x3, short y3, short tx1, short ty1, short tx2, short ty2, short tx3, short ty3)
{
 long num; 
 long i,j;
 long difX, difY;
 long posX,posY;
 unsigned short color;
  
 if(x1>drawW && x2>drawW && x3>drawW) return;
 if(y1>drawH && y2>drawH && y3>drawH) return;
 if(x1<drawX && x2<drawX && x3<drawX) return;
 if(y1<drawY && y2<drawY && y3<drawY) return;
 Ymin = 512;
 Ymax = 0;
 for(i=511;i>=0;i--)
  {
   Xmin[i]=1024; Xmax[i]=0;
  }
 drawLineInBufT(x1,y1,x2,y2,tx1,ty1,tx2,ty2);
 drawLineInBufT(x2,y2,x3,y3,tx2,ty2,tx3,ty3);
 drawLineInBufT(x3,y3,x1,y1,tx3,ty3,tx1,ty1);
 
 if (Ymin>Ymax) return;

 for (i=Ymin;i<Ymax;i++)
  {
   if(Xmin[i]<=Xmax[i])
     {
      num=(Xmax[i]-Xmin[i]);
      if(num==0)num=1;
      difX=(TXmax[i]-TXmin[i])/num;
      difY=(TYmax[i]-TYmin[i])/num;
      posX=TXmin[i];
      posY=TYmin[i];
      for(j=Xmin[i];j<Xmax[i];j++)
       {
        if((color = psxVuw[((posY>>16)+textAddrY)*1024+(posX>>16)+textAddrX]))
         psxVuw[i*1024+j] = color;
        posX+=difX;
        posY+=difY;
       }
     }
   }
}


// ------------------------------------------------
void drawLine(short x1, short y1, short x2, short y2)
{
 short deltax, deltay, numpixels;
 short i;
 short d, dinc1, dinc2;
 short x, y;
 short xinc1, xinc2;
 short yinc1, yinc2;

 deltax = abs(x2-x1);
 deltay = abs(y2-y1);

 if (deltax>=deltay)
  {
   numpixels = deltax;
   d = (2*deltay)-deltax;
   dinc1 = deltay << 1;
   dinc2 = (deltay - deltax) << 1;
   xinc1 = 1;
   xinc2 = 1;
   yinc1 = 0;
   yinc2 = 1;
  }
 else
  {
   numpixels = deltay;
   d = (2*deltax)-deltay;
   dinc1 = deltax << 1;
   dinc2 = (deltax - deltay) << 1;
   xinc1 = 0;
   xinc2 = 1;
   yinc1 = 1;
   yinc2 = 1;
  }

 if (x1>x2)
  {
   xinc1 = (-xinc1);
   xinc2 = (-xinc2);
  }
 if (y1>y2)
  {
   yinc1 = (-yinc1);
   yinc2 = (-yinc2);
  }
 x = x1; y = y1;
 if(numpixels<0) return;
 for (i=numpixels;i>=0;i--)
  {
   if ((drawX<x && x<drawW) && (drawY<y && y<drawH)) 
    psxVuw[(y<<10)+x] = 0xffff;
   if (d<0)
    {
     d += dinc1;
     x += xinc1;
     y += yinc1;
    }
   else
    {
     d += dinc2;
     x += xinc2;
     y += yinc2;
    }
  }
}






//=======================================================================
// routines to convert 4-bit & 8-bit textures to direct color 
void fillText4Buffer3V(short tx0, short ty0, short tx1, short ty1, short tx2, short ty2, short clX, short clY)
{
 short textXmin;
 short textXmax;
 short textYmin;
 short textYmax;
 short cX,cY;
 long textY,textX;
 char tC;
 long clutP;
 
 textXmin = tx0;
 if (tx1<textXmin) textXmin=tx1;
 if (tx2<textXmin) textXmin=tx2;
 textXmax = tx0;
 if (tx1>textXmax) textXmax=tx1;
 if (tx2>textXmax) textXmax=tx2;
 textYmin = ty0;
 if (ty1<textYmin) textYmin=ty1;
 if (ty2<textYmin) textYmin=ty2;
 textYmax = ty0;
 if (ty1>textYmax) textYmax=ty1;
 if (ty2>textYmax) textYmax=ty2;
 
 newTextX0 = tx0-textXmin;
 newTextX1 = tx1-textXmin;
 newTextX2 = tx2-textXmin;
 
 newTextY0 = ty0-textYmin;
 newTextY1 = ty1-textYmin;
 newTextY2 = ty2-textYmin;

 clutP=clY*1024+clX;

 textY=(textYmin+textAddrY)*2048;
 
 for (cY=0;cY<(textYmax-textYmin);cY++)
  {
   textX=textAddrX*2+textXmin/2;
   for (cX=0;cX<((textXmax-textXmin)*2);cX+=2)
    { 
     tC = psxVub[textY + textX];
     textBuf[cY*512+cX] = psxVuw[clutP+(tC & 0xf)];
     textBuf[cY*512+cX+1] = psxVuw[clutP+((tC>>4)&0xf)];
     textX++;
    }
   textY+=2048;
  }
}

void fillText8Buffer3V(short tx0, short ty0, short tx1, short ty1, short tx2, short ty2, short clX, short clY)
{
 short textXmin;
 short textXmax;
 short textYmin;
 short textYmax;
 short cX,cY;
 long textY,textX;
 long clutP;
 
 textXmin = tx0;
 if (tx1<textXmin) textXmin=tx1;
 if (tx2<textXmin) textXmin=tx2;

 textXmax = tx0;
 if (tx1>textXmax) textXmax=tx1;
 if (tx2>textXmax) textXmax=tx2;
 
 textYmin = ty0;
 if (ty1<textYmin) textYmin=ty1;
 if (ty2<textYmin) textYmin=ty2;

 textYmax = ty0;
 if (ty1>textYmax) textYmax=ty1;
 if (ty2>textYmax) textYmax=ty2;
 
 newTextX0 = tx0-textXmin;
 newTextX1 = tx1-textXmin;
 newTextX2 = tx2-textXmin;
 
 newTextY0 = ty0-textYmin;
 newTextY1 = ty1-textYmin;
 newTextY2 = ty2-textYmin;

 clutP=clY*1024+clX;

 textY=(textYmin+textAddrY)*2048;
 
 for (cY=0;cY<(textYmax-textYmin);cY++)
  {
   textX=textAddrX*2+textXmin;
   for (cX=0;cX<((textXmax-textXmin));cX++)
    { 
     textBuf[cY*512+cX] = psxVuw[clutP+psxVub[textY + textX]];
     textX++;
    }
   textY+=2048;
  }
}

void fillText4Buffer4(short tx0, short ty0, short tx1, short ty1, short tx2, short ty2, short tx3, short ty3, short clX, short clY)
{
 short textXmin;
 short textXmax;
 short textYmin;
 short textYmax;
 short cX,cY;
 long textY,textX;
 char tC;
 long clutP;
 
 textXmin = tx0;
 if (tx1<textXmin) textXmin=tx1;
 if (tx2<textXmin) textXmin=tx2;
 if (tx3<textXmin) textXmin=tx3;

 textXmax = tx0;
 if (tx1>textXmax) textXmax=tx1;
 if (tx2>textXmax) textXmax=tx2;
 if (tx3>textXmax) textXmax=tx3;
 
 textYmin = ty0;
 if (ty1<textYmin) textYmin=ty1;
 if (ty2<textYmin) textYmin=ty2;
 if (ty3<textYmin) textYmin=ty3;

 textYmax = ty0;
 if (ty1>textYmax) textYmax=ty1;
 if (ty2>textYmax) textYmax=ty2;
 if (ty3>textYmax) textYmax=ty3;
 
 newTextX0 = tx0-textXmin;
 newTextX1 = tx1-textXmin;
 newTextX2 = tx2-textXmin;
 newTextX3 = tx3-textXmin;
 
 newTextY0 = ty0-textYmin;
 newTextY1 = ty1-textYmin;
 newTextY2 = ty2-textYmin;
 newTextY3 = ty3-textYmin;

 clutP=clY*1024+clX;

 textY=(textYmin+textAddrY)*2048;
 
 for (cY=0;cY<(textYmax-textYmin);cY++)
  {
   textX=textAddrX*2+textXmin/2;
   for (cX=0;cX<((textXmax-textXmin)*2);cX+=2)
    { 
     tC = psxVub[textY + textX];
     textBuf[cY*512+cX] = psxVuw[clutP+(tC & 0xf)];
     textBuf[cY*512+cX+1] = psxVuw[clutP+((tC>>4)&0xf)];
     textX++;
    }
   textY+=2048;
  }
}

void fillText8Buffer4(short tx0, short ty0, short tx1, short ty1, short tx2, short ty2, short tx3, short ty3, short clX, short clY)
{
 short textXmin;
 short textXmax;
 short textYmin;
 short textYmax;
 short cX,cY;
 long textY,textX;
 long clutP;
 
 textXmin = tx0;
 if (tx1<textXmin) textXmin=tx1;
 if (tx2<textXmin) textXmin=tx2;
 if (tx3<textXmin) textXmin=tx3;

 textXmax = tx0;
 if (tx1>textXmax) textXmax=tx1;
 if (tx2>textXmax) textXmax=tx2;
 if (tx3>textXmax) textXmax=tx3;
 
 textYmin = ty0;
 if (ty1<textYmin) textYmin=ty1;
 if (ty2<textYmin) textYmin=ty2;
 if (ty3<textYmin) textYmin=ty3;

 textYmax = ty0;
 if (ty1>textYmax) textYmax=ty1;
 if (ty2>textYmax) textYmax=ty2;
 if (ty3>textYmax) textYmax=ty3;
 
 newTextX0 = tx0-textXmin;
 newTextX1 = tx1-textXmin;
 newTextX2 = tx2-textXmin;
 newTextX3 = tx3-textXmin;
 
 newTextY0 = ty0-textYmin;
 newTextY1 = ty1-textYmin;
 newTextY2 = ty2-textYmin;
 newTextY3 = ty3-textYmin;

 clutP=clY*1024+clX;

 textY=(textYmin+textAddrY)*2048;
 for (cY=0;cY<(textYmax-textYmin);cY++)
  {
   textX=textAddrX*2+textXmin;
   for (cX=0;cX<((textXmax-textXmin));cX++)
    { 
     textBuf[cY*512+cX] = psxVuw[clutP+psxVub[textY + textX]];
     textX++;
    }
   textY+=2048;
  }
}




//===============================================================
// routine that initializes lookup tables BGR16->RGB15
// also this routine initializes other parameters which are
// linked with display routines...
// the lookup table is used by updateDisplay() function

void fillLookupTables(void)
{
 long i;
 for(i=0;i<65536;i++)
  {
   lutBGR2RGB[i]=(i&0x8000)| ((i&0x7c00)>>10) | (i&0x03e0) | ((i&0x1f)<<10);
  }
 updateLace=5; // update period when PSX don't want to change display (every 5th VSync)
 dispMode = 0; // holds current display mode (0 = no mode - assume 640)
}

/*

void updateDisplay(void)
{
 short i;
 short j;
 long maxVer,maxHor;
 long iInc,jInc;
 unsigned short color;
  
 updateLace=5; // update period when PSX don't want to change display (every 5th VSync)
 if(dispVer==0) return; // when no display is set

 // check if display is set within frame buffer
 if(dispPosX>=1024) return; 
 if(dispPosY>=512) return;

 maxVer=dispVer;
 maxHor=dispHor;
 iInc=0;jInc=0;
 // dunno how playstation handles things when display is set that the
 // framebuffer rolls over... I'm just cutting this.
 if((dispPosX+maxHor)>=1024) maxHor=1024-dispPosX;
 if((dispPosY+maxVer)>=512) maxVer=512-dispPosY;

 maxHor<<=1; // multiplied by 2 'coz we operate on shorts
 if (dispVer==240)
  {
   if(dispHor<=320)
    {
     return;
    } // end of dispHor<=320
   else
    { // dispHor>320
     for (i=0;i<240;i++)
      {
       iInc=i*1280*2;
       jInc=(dispPosY+i)*1024+dispPosX;
       for (j=0;j<maxHor;j+=2)
        {
         color = lutBGR2RGB[psxVuw[jInc++]];
//         _farnspokew(iInc+j    , color);
//         _farnspokew(iInc+j+1280, color);
        }
      }
     return;
    } // end of dispHor>320
  } 
 else
  {
   if(dispHor<=320)
    {
//     _farsetsel(dispBuffer);
     maxHor<<=1;
     for (i=0;i<480;i++)
      {
       iInc=i*1280;
       jInc=(dispPosY+i)*1024+dispPosX;
       for (j=0;j<maxHor;j+=4)
        {
         color = lutBGR2RGB[psxVuw[jInc++]];
//         _farnspokew(iInc+j, color);
//         _farnspokew(iInc+j+2, color);
        }
      }
     return;
    } // end of dispHor<=320
   else
    { // dispHor>320
//     _farsetsel(dispBuffer);
     for (i=0;i<480;i++)
      {
       iInc=i*1280;
       jInc=(dispPosY+i)*1024+dispPosX;
       for (j=0;j<maxHor;j+=2)
        {
//         _farnspokew(iInc+j, lutBGR2RGB[psxVW[jInc++]]);
        }
      }
     return;
    } // end of dispHor>320
  } 

}


*/