#ifndef _GPU_INTERNALS_H
#define _GPU_INTERNALS_H

#ifdef GPU_INTERNALS_DEF
#define GPUVAR_DEF
#else
#define GPUVAR_DEF extern
#endif

void syslog(int level, char *fmt,...);

extern unsigned short lutBGR2RGB[65536];

extern unsigned short textBuf[];

extern long GPUstatusRet;

GPUVAR_DEF long textAddrY,textAddrX, textAddrX2;

GPUVAR_DEF long drawY;
GPUVAR_DEF long drawX;
GPUVAR_DEF long drawW;
GPUVAR_DEF long drawH;
GPUVAR_DEF long ofsX;
GPUVAR_DEF long ofsY;
GPUVAR_DEF long textTP;
GPUVAR_DEF long textREST;
GPUVAR_DEF long textABR;

extern long dispWidths[4];
extern long dispPosX;
extern long dispPosY;
extern long dispVer;
extern long dispHor;
extern long dispHorNew;
extern long dispVerNew;
extern long dispColor;
extern long dispColorNew;
extern long dispLace;
extern long dispLaceNew;
extern long imageTransfer;
extern long drawLace;
extern long drawingLines;

extern short imTYc,imTXc,imTY,imTX;
extern long imSize;
extern short imageX0,imageX1;
extern short imageY0,imageY1;


extern long newTextX0,newTextX1,newTextX2,newTextX3;
extern long newTextY0,newTextY1,newTextY2,newTextY3;
extern unsigned short textBuf[];

extern unsigned char psxVub[];
extern signed char *psxVsb;
extern unsigned short *psxVuw;
extern signed short *psxVsw;
extern unsigned long *psxVul;
extern signed long *psxVsl;

typedef struct
{
	char scanH;
	char scanV;
} GpuConfS;

#endif // _GPU_INTERNALS_H